#ifndef LINKED_LIST_H
#define LINKED_LIST_H

#include <stdlib.h>

struct linked_list {
	void *elem;
	struct linked_list *next;
};

#define ITERATOR(LIST_NAME) _iter_##LIST_NAME

#define DECLARE_LIST(NAME) struct linked_list *NAME, *ITERATOR(NAME)

#define INITIALIZE_LIST(NAME) \
NAME = (struct linked_list *)malloc(sizeof(struct linked_list)); \
NAME->elem = NULL; \
NAME->next = NULL; \
ITERATOR(NAME) = NAME

#define PUSH(TYPE, X, LIST) \
do { \
	ITERATOR(LIST) = ITERATOR(LIST)->next = (struct linked_list *)malloc(sizeof(struct linked_list)); \
	ITERATOR(LIST)->elem = malloc(sizeof(TYPE)); \
	*(TYPE *)ITERATOR(LIST)->elem = X; \
	ITERATOR(LIST)->next = NULL; \
} while (0)

#define DESTROY_LIST(LIST) \
do { \
	struct linked_list *l; \
	ITERATOR(LIST) = LIST; \
	do { \
		l = ITERATOR(LIST)->next; \
		free(ITERATOR(LIST)->elem); \
		free(ITERATOR(LIST)); \
	} while ((ITERATOR(LIST) = l) != NULL); \
} while (0)

#endif